########################################################
#          AvatarAutoChange PLUGIN NAMESPACE
########################################################
# Maintainer: sethnakht - sethnakht_fox@yahoo.com
# Created: 01/06/2007
########################################################

namespace eval ::AvatarAutoChange {
	
	#//////////////////////////////////////////////////////////////////////////
	#                          CORE PROCEDURES
	#//////////////////////////////////////////////////////////////////////////

	################################################
	# this starts AvatarAutoChange
	proc AvatarAutoChangeStart { dir } {
		#variables
    global lastState
    variable external_commands
		array set ::AvatarAutoChange::external_commands [list]
		
		# init
    ::plugins::RegisterPlugin AvatarAutoChange
    ::plugins::RegisterEvent AvatarAutoChange ChangeMyState ChangeTheAvatar 
    ::plugins::RegisterEvent AvatarAutoChange PluginConfigured  AAC_PluginConfigured  
    #::plugins::RegisterEvent AvatarAutoChange ContactListColourBarDrawn MyDisplayPictureChange 

		array set ::AvatarAutoChange::config {
        NLN_pic2 ""
        IDL_pic2 ""
        BSY_pic2 ""
        BRB_pic2 ""
        AWY_pic2 ""
        PHN_pic2 ""
        LUN_pic2 ""
        HDN_pic2 ""
        automatic_resize 1
        use_webcam_pic 0
		}
		set ::AvatarAutoChange::configlist [ list \
			[list label  "[trans selectimage]" ] \
			[list frame ::AvatarAutoChange::buildConfig ""] \
			[list bool "[trans resizeimage]" automatic_resize] \
		]
		
    set langdir [file join $dir "lang"]
    set lang [::config::getGlobalKey language]
    load_lang en $langdir
    load_lang $lang $langdir 
    
    #init global vars
		set lastState [::MSN::myStatusIs]
		
	}
		#	[list bool "[trans use_webcam]" use_webcam_pic] \
		
	proc AvatarAutoChangeStop { dir } {
	}
	
	####################################################
	# buildConfig procedure, build config window
	proc buildConfig { {win} } {
    
	  # Save the state 
	  saveState
	  
	  #build config
    frame $win.allStatus
	  set frm $win
    ScrolledWindow $frm.sw  
	  ScrollableFrame $frm.sw.sf  -constrainedwidth 1
	  $frm.sw setwidget $frm.sw.sf
	  pack $frm.sw -anchor n -side top -expand true -fill both
	  set frm [$frm.sw.sf getframe]	
			      
    catch {image delete imageNLN}
    image create photo imageNLN  -file [getSmallFileName $::AvatarAutoChange::config(NLN_pic2)]
		frame $frm.frameNLN
    ::AvatarAutoChange::buildConfig2 $frm $frm.frameNLN imageNLN NLN ::AvatarAutoChange::config(NLN_pic2) "[trans online]"
    
    catch {image delete imageIDL}
    image create photo imageIDL  -file [getSmallFileName $::AvatarAutoChange::config(IDL_pic2)]
		frame $frm.frameIDL
    ::AvatarAutoChange::buildConfig2 $frm $frm.frameIDL imageIDL IDL ::AvatarAutoChange::config(IDL_pic2) "[trans noactivity]"

    catch {image delete imageBSY}
    image create photo imageBSY  -file [getSmallFileName $::AvatarAutoChange::config(BSY_pic2)]
		frame $frm.frameBSY
    ::AvatarAutoChange::buildConfig2 $frm $frm.frameBSY imageBSY BSY ::AvatarAutoChange::config(BSY_pic2) "[trans busy]"

    catch {image delete imageBRB}
    image create photo imageBRB  -file [getSmallFileName $::AvatarAutoChange::config(BRB_pic2)]
		frame $frm.frameBRB
    ::AvatarAutoChange::buildConfig2 $frm $frm.frameBRB imageBRB BRB ::AvatarAutoChange::config(BRB_pic2) "[trans rightback]"

    catch {image delete imageAWY}
    image create photo imageAWY  -file [getSmallFileName $::AvatarAutoChange::config(AWY_pic2)]
		frame $frm.frameAWY
    ::AvatarAutoChange::buildConfig2 $frm $frm.frameAWY imageAWY AWY ::AvatarAutoChange::config(AWY_pic2) "[trans away]"

    catch {image delete imagePHN}
    image create photo imagePHN  -file [getSmallFileName $::AvatarAutoChange::config(PHN_pic2)]
		frame $frm.framePHN
    ::AvatarAutoChange::buildConfig2 $frm $frm.framePHN imagePHN PHN ::AvatarAutoChange::config(PHN_pic2) "[trans onphone]"

    catch {image delete imageLUN}
    image create photo imageLUN  -file [getSmallFileName $::AvatarAutoChange::config(LUN_pic2)]
		frame $frm.frameLUN
    ::AvatarAutoChange::buildConfig2 $frm $frm.frameLUN imageLUN LUN ::AvatarAutoChange::config(LUN_pic2) "[trans gonelunch]"

    #catch {image delete imageHDN}
    #image create photo imageHDN  -file [getSmallFileName $::AvatarAutoChange::config(HDN_pic2)]
		#frame $frm.frameHDN
    #::AvatarAutoChange::buildConfig2 $frm $frm.frameHDN imageHDN HDN ::AvatarAutoChange::config(HDN_pic2) "[trans appearoff]"
		
	}
	####################################################
	# buildConfig2 procedure, chose file and resize it
  proc buildConfig2 { {mainFrame ""} {frame ""} {image ""}  {state ""} {state_pic2 ""} {statemessage ""} } {
 	  #::CxImage::Resize $image 50 50
    label $frame.label -text "$statemessage" -width 20
 	  label $frame.photo -image $image -bg white  -borderwidth 1
 	  entry $frame.entry -textvariable $state_pic2 -bg white
		frame $frame.bframe
    button $frame.bframe.browse -text [trans browse]... -command [list ::AvatarAutoChange::MyChooseFileDialog $frame.entry $image ]
    button $frame.bframe.delete -text [trans nopic] -command [list ::AvatarAutoChange::NoAvatar $frame.entry $image ]
		
    Separator $frame.separator -orient horizontal	
		pack $frame.bframe.browse -anchor w
    pack $frame.separator -anchor w -pady 5
		pack $frame.bframe.delete  -anchor w 
     
    pack $frame.label -side left -anchor w
		pack $frame.photo -side left -anchor w
		#pack $frame.entry -side right -anchor w
    pack $frame.bframe -side left -anchor w
    
    
		pack $frame -anchor w -padx 5
  }
  
	####################################################
	# createMiniImage procedure, ceate a 96x96 image
  proc createMiniImage { { file "" } } {
		set new_file [getSmallFileName $file]
    createMiniImage2 $file $new_file
  }
  
  proc createMiniImage2 { { file "" } { new_file "" } } {

		if { $file == "" } {
      return; 
    }
		
		
    catch {file attributes $new_file -permissions 0777}

    #plugins_log "AvatarAutoChange" "Resize $file"
    #plugins_log "AvatarAutoChange" "Resize $new_file"
    
    catch {image delete dpToResize}
    if { [catch {image create photo dpToResize -file $file -format cximage}] } {
      image create photo dpToResize
    }
			
    ::picture::ResizeWithRatio dpToResize 96 96
			
		if {[catch {::picture::ResizeWithRatio dpToResize 96 96} res]} {
      #plugins_log "AvatarAutoChange" "can't resize picture"
    }
	
	  if {[catch {::picture::Save dpToResize $new_file cxpng} res] } {
      #plugins_log "AvatarAutoChange" "can't save resized picture"
	  }

  }
    
	####################################################
	# MyChooseFileDialog procedure, chose file and resize it
  proc MyChooseFileDialog { {entry ""} {image ""} } {
    
    set file [chooseFileDialog "" "" "" "" open [list [list [trans imagefiles] [list *.gif *.GIF *.jpg *.JPG *.bmp *.BMP *.png *.PNG]] [list [trans allfiles] *]]]
    
		if { $file == "" } {
      return; 
    }
		
	  createMiniImage $file
		set new_file [getSmallFileName $file]
	  
		if { $entry != "" } {
			$entry delete 0 end
			$entry insert 0 $file
			# Next line has caused some problems with an old Tile version
			catch { $entry xview end }
		} 
		if { $image != "" } {
			#::CxImage::Resize $image 50 50
			$image configure -file $new_file
		}
		
		# Change in the client if current state 
    # setAvatar $file [::MSN::myStatusIs]
  }
	####################################################
	# NoAvatar procedure, chose file and resize it
  proc AAC_PluginConfigured  { event evPar } {
		#plugins_log "AvatarAutoChange" "AAC_PluginConfigured***********************"
		upvar 2 $evPar vars
		set name $vars(name)
		#plugins_log "AvatarAutoChange" "AAC_PluginConfigured*********************** $name"
		if { $name == "AvatarAutoChange" } {
      ChangeTheAvatar2 [::MSN::myStatusIs]
    }
  }
    
	####################################################
	# NoAvatar procedure, chose file and resize it
  proc NoAvatar { {entry ""} {image ""}} {
    $entry delete 0 end
    set file [::skin::GetSkinFile displaypic nopic.gif]
		$image configure -file $file
  }
  
	####################################################
	# getSmallFileName procedure 
	proc getSmallFileName { {file "" } } {
		if { ([file exists "$file"] == 0) } {   
      return [::skin::GetSkinFile displaypic nopic.gif]
    }
    
    global HOME2 tlsplatform
		set plugin_path "plugins"
		set my_plugin_path "AvatarAutoChange"
		set my_home "[file join $HOME2 $plugin_path]"
		#set my_home "[file join $HOME2 $plugin_path $my_plugin_path]"
		set new_file [file rootname [file tail $file]]_AAC_96[file extension $file]
		set new_file_path "[file join $my_home $new_file]"
		
		#resizes pic if missing
		if { ([file exists "$new_file_path"] == 0) } {
      createMiniImage2 $file $new_file_path
    }
		
		return $new_file_path
	}
	
	####################################################
	# MyDisplayPictureChange procedure, set the new avatar and send to 
	proc MyDisplayPictureChange { event evPar } {
      # get the picture
			set image_name [::config::getKey displaypic]
			set my_status [::MSN::myStatusIs]
			#plugins_log "AvatarAutoChange" "*********************** $image_name"
			#plugins_log "AvatarAutoChange" "*********************** $my_status"
      
      # save the image for the state according to the state
      switch -- $my_status {
        "NLN" {
            set $image_name ::AvatarAutoChange::config(NLN_pic2)
        }
        "IDL" {
            set $image_name ::AvatarAutoChange::config(IDL_pic2)
        }
        "BSY" {
            set $image_name ::AvatarAutoChange::config(BSY_pic2)
        }
        "BRB" {
            set $image_name ::AvatarAutoChange::config(BRB_pic2)
        }
        "AWY" {
            set $image_name ::AvatarAutoChange::config(AWY_pic2)
        }
        "PHN" {
            set $image_name ::AvatarAutoChange::config(PHN_pic2)
        }
        "LUN" {
            set $image_name ::AvatarAutoChange::config(LUN_pic2)
        }
        "HDN" {
            set $image_name ::AvatarAutoChange::config(HDN_pic2)
        }
      }
			#plugins_log "AvatarAutoChange" "set_displaypic=======$image_name   for state=[$::MSN::myStatusIs]"
   }

	####################################################
	# ChangeTheAvatar procedure, set the new avatar
	proc ChangeTheAvatar { event epvar } {
	  #plugins_log "AvatarAutoChange" "ChangeTheAvatar"
    global lastState
	  # Save the state 
	  saveState
	   
		upvar 2 $epvar vars
		set idx $vars(idx)
		
		
		#plugins_log "AvatarAutoChange" "### idx = $idx ###"
    if { "new_state" == $idx} {
		   upvar 2 new_state new_state
		   set idx $new_state 
    }
		
		set lastState $idx 
		ChangeTheAvatar2 $idx
	}
	
	####################################################
	# ChangeTheAvatar procedure, set the new avatar
	proc ChangeTheAvatar2 { {new_state ""} } {
		#plugins_log "AvatarAutoChange" "### ChangeTheAvatar2  $new_state ###"
	
    switch -- $new_state {
        "NLN" {
            setAvatar $::AvatarAutoChange::config(NLN_pic2) NLN
        }
        "IDL" {
            setAvatar $::AvatarAutoChange::config(IDL_pic2) IDL
        }
        "BSY" {
            setAvatar $::AvatarAutoChange::config(BSY_pic2) BSY
        }
        "BRB" {
            setAvatar $::AvatarAutoChange::config(BRB_pic2) BRB
        }
        "AWY" {
            setAvatar $::AvatarAutoChange::config(AWY_pic2) AWY
        }
        "PHN" {
            setAvatar $::AvatarAutoChange::config(PHN_pic2) PHN
        }
        "LUN" {
            setAvatar $::AvatarAutoChange::config(LUN_pic2) LUN
        }
        "HDN" {
            setAvatar $::AvatarAutoChange::config(HDN_pic2) HDN
        }
    }
	} 
	
	
	
	####################################################
	# saveState procedure, save the last image for the last state 
	proc saveState { } {
	 	
		# Save the current image
    global lastState
    set image_name [::config::getKey displaypic]
		
	  #plugins_log "AvatarAutoChange" "saveState ========== lastState=$lastState   image_name=$image_name"
	  
    set indexofaac96 [string first "_AAC_96" $image_name]
    if { $indexofaac96 < 0 } {
      switch -- $lastState {
        "NLN" {
            set ::AvatarAutoChange::config(NLN_pic2) $image_name
        }
        "IDL" {
            set ::AvatarAutoChange::config(IDL_pic2) $image_name
        }
        "BSY" {
            set ::AvatarAutoChange::config(BSY_pic2) $image_name
        }
        "BRB" {
            set ::AvatarAutoChange::config(BRB_pic2) $image_name
        }
        "AWY" {
            set ::AvatarAutoChange::config(AWY_pic2) $image_name
        }
        "PHN" {
            set ::AvatarAutoChange::config(PHN_pic2) $image_name
        }
        "LUN" {
            set ::AvatarAutoChange::config(LUN_pic2) $image_name
        }
        "HDN" {
            set ::AvatarAutoChange::config(HDN_pic2) $image_name
        }
      }
    }
	}
	
	####################################################
	# setAvatar procedure, set the new avatar and send to 
	proc setAvatar { file new_state } {
	  #plugins_log "AvatarAutoChange" "setAvatar ##### file = $file"
	  		if { $file == "" } {
		
  			clear_disp
  			::MSN::WriteSB ns "CHG" "$new_state [::config::getKey clientid]"
		  
		} else {
		
      if {$::AvatarAutoChange::config(automatic_resize)==1} {
        set file [getSmallFileName $file]
  	  }
  			
      if { $file != "" } {
  			#plugins_log "AvatarAutoChange" "set_displaypic: File set to $file"
  			::config::setKey displaypic $file
  			load_my_pic
  		  
        if { [::config::getKey displaypic] != "nopic.gif" } {
  			    ::MSN::WriteSB ns "CHG" "$new_state [::config::getKey clientid] [urlencode [create_msnobj [::config::getKey login] 3 [::skin::GetSkinFile displaypic [::config::getKey displaypic]]]]"
  		  }
  		} else {
        #plugins_log "AvatarAutoChange" "set_displaypic: Setting displaypic to [::skin::getNoDisplayPicture]"
  			clear_disp
  			::MSN::WriteSB ns "CHG" "$new_state [::config::getKey clientid]"
      }
    }
  }
}

