namespace eval ::bigsmileys {
	
	proc Init { dir } {
		::plugins::RegisterPlugin "BigSmileys"
		::plugins::RegisterEvent "BigSmileys" chatwindowbutton AddBigSmileysButton
		::skin::setPixmap butbigsmileys bigsmileysbut.png pixmaps [file join $dir pixmaps]
		::skin::setPixmap butbigsmileys_hover bigsmileysbut_hover.png pixmaps [file join $dir pixmaps]
		array set ::bigsmileys::config {
				sort_by_cat 1
		}
		set ::bigsmileys::configlist [ list \
				[list bool "Sort by category." sort_by_cat] \
		]
	}
	proc DeInit { dir } {
		BigSmileysMenuDestroy
	}
	
	proc AddBigSmileysButton { event evpar } {
		upvar 2 $evpar newvar

		set buttonbar $newvar(bottom)		

		set bigsmileybut $buttonbar.bigsmileybut
		label $bigsmileybut -image [::skin::loadPixmap butbigsmileys] -relief flat -padx 0 \
			-background [::skin::getKey buttonbarbg] -highlightthickness 0 -borderwidth 0 \
			-highlightbackground [::skin::getKey buttonbarbg] -activebackground [::skin::getKey buttonbarbg]
		pack $bigsmileybut -side left -padx 0 -pady 0

		set window $newvar(window_name)	
		
		if {$::bigsmileys::config(sort_by_cat)} {
			bind $bigsmileybut  <<Button1>> "::bigsmileys::BigSmileysMenuCat \[winfo pointerx $window\] \[winfo pointery $window\] [::ChatWindow::GetInputText $window]"
		} else {
			bind $bigsmileybut  <<Button1>> "::bigsmileys::BigSmileysMenu \[winfo pointerx $window\] \[winfo pointery $window\] [::ChatWindow::GetInputText $window] \"\" 0"
		}
		bind $bigsmileybut  <<Button3>> "::bigsmileys::BigSmileysMenuDestroy"
		bind $bigsmileybut  <Enter> "$bigsmileybut configure -image [::skin::loadPixmap butbigsmileys_hover]"
		bind $bigsmileybut  <Leave> "$bigsmileybut configure -image [::skin::loadPixmap butbigsmileys]"	
	}
	
	
	proc BigSmileysMenuDestroy { } {
		if { [winfo exists .smile_selectorBig_c]} {destroy .smile_selectorBig_c}
		if { [winfo exists .changeSmileyCat]} {destroy .changeSmileyCat}
		if { [winfo exists .smile_selectorBigCat]} {destroy .smile_selectorBigCat}
		global custom_emotions_categories
		foreach categ [array names custom_emotions_categories] {
			if { [winfo exists .smile_selectorBig_c$categ ] } { destroy .smile_selectorBig_c$categ }
		}
	}
	
	proc ChangeSmileyCategory { ename ecateg } {
		set w .changeSmileyCat
		if { [winfo exists .changeSmileyCat]} {destroy .changeSmileyCat}
		toplevel $w
		wm group $w .
		wm title $w "Change Smiley Category - $ename"
	
		frame $w.fn
		label $w.fn.label -font sboldf -text "Introduce Category:"
		entry $w.fn.name -width 40 -bg #FFFFFF -font splainf
	
		frame $w.fb
		button $w.fb.ok -text [trans ok] -command "::bigsmileys::ChangeSmileyCategoryOk \"$ename\""
		button $w.fb.cancel -text [trans cancel] -command "destroy $w"
		bind $w <<Escape>> "destroy $w"
	
		pack $w.fn.label $w.fn.name -side left -fill x -expand true
		pack $w.fb.ok $w.fb.cancel -side right -padx 5
	
		bind $w.fn.name <Return> "::bigsmileys::ChangeSmileyCategoryOk \"$ename\""
		pack $w.fn $w.fb -side top -fill x -expand true -padx 5
		
		$w.fn.name insert 0 "$ecateg"
	
		catch {
			raise $w
			focus -force $w.fn.name
		}
		moveinscreen $w 50
	}
	
	proc ChangeSmileyCategoryOk { ename } {
		set ecateg [.changeSmileyCat.fn.name get]
		global custom_emotions
		foreach name [array names custom_emotions] {
			array set emotion $custom_emotions($name)
			if { $emotion(name) == $ename } {
				set emotion(category) "$ecateg"
				tk_messageBox -message "$emotion(category)"
				set custom_emotions($name) [array get emotion]
				BigSmileysMenuDestroy
				return
			}
		}
		
	}
	
	
		
	proc BigCreateSmileyInMenu {w cols rows smiw smih emot_num emot_pos name symbol image file animated} {
		catch {
			set resized [image create photo]
			$resized copy $image
			if {[image width $image] > 44 && [image height $image] > 44} {
				::picture::ResizeWithRatio $resized 44 44
							}
			label $w.$emot_num -image $resized -background [$w cget -background]
			bind $w.$emot_num <Destroy> "image delete $resized"
	
			$w.$emot_num configure -cursor hand2 -borderwidth 1 -relief flat
			
			#Bindings for raise/flat on mouse over
			bind $w.$emot_num <Enter>  [list $w.$emot_num configure -relief raised]
			bind $w.$emot_num <Leave> [list $w.$emot_num configure -relief flat]

			#Tooltip
			if { [::config::getKey tooltips] } {set_balloon $w.$emot_num "$name\n[trans triggers]: $symbol" "$image"}
			set xpos [expr {($emot_pos % $cols)* $smiw}]
			set ypos [expr {($emot_pos / $cols) * $smih}]
			$w create window $xpos $ypos -window $w.$emot_num -anchor nw -width $smiw -height $smih
		}
	}


	proc BigSmileysMenuCat { {x 0} {y 0} {text text}} {
		
		
		
		global emotions_names 
		global custom_emotions_categories
		
		set w .smile_selectorBigCat
		
		if { ! [winfo exists $w]} { 
			BigCreateSmileyMenuCat $text
		}
		
		wm state $w normal
		set x [expr {$x - 15}]
		set y [expr {$y + 15 - [winfo height $w]}]
		wm geometry $w +$x+$y
		#It won't work on Windows without this
		update idletasks
		
		
		#It won't work on Windows without this
		raise $w
		set categ_num 0
		
		foreach categ [array names custom_emotions_categories] {
			if { $custom_emotions_categories($categ) > 0 } {
				bind $w.c.$categ_num <Button1-ButtonRelease> "bind .smile_selectorBigCat <Leave> \"\";::bigsmileys::BigSmileysMenu \[winfo pointerx $w\] \[winfo pointery $w\] $text $categ $custom_emotions_categories($categ)"
				incr categ_num
			}
		}		
		
		
		#Add bindings for standard emotions
		moveinscreen $w 5
		event generate $w <Enter>
	
	}

	proc BigSmileysMenu { {x 0} {y 0} {text text} categ categnum} {
		
		global emotions_names custom_emotions
		
		set w .smile_selectorBig_c$categ
		
		if { $categnum == 0 } { 
			set categnum [array size custom_emotions]
			set categ ""
			
		}
		
		if { ! [winfo exists $w]} { 
			BigCreateSmileyMenu $categ $categnum
		}
		
		
		wm state $w normal
		set x [expr {$x - 15}]
		set y [expr {$y + 15 - [winfo height $w]}]
		wm geometry $w +$x+$y
		#It won't work on Windows without this
		update idletasks
		
		
		#It won't work on Windows without this
		raise $w
		
		set temp 0

		#Add custom emotions bindings
		global custom_emotions
		foreach name [array names custom_emotions] {
			
			set tmp_do 0
			array set emotion $custom_emotions($name)
			if { "$categ" == "" } { set tmp_do 1 }
			if { [info exists emotion(category)] && $emotion(category) == $categ } { set tmp_do 1 }
			if { ![info exists emotion(category)] && "$categ" == [trans others]  } { set tmp_do 1 }
			if { $tmp_do == 1 } {			
				
				set symbol [lindex $emotion(text) 0]
				
				#This must be cached due to a race condition (if you double click
				#the smileys menu for first time, the second click can launch
				#this procedure without all smileys having been created
				catch { 
					#TODO: Improve this now we know about quoting a bit more?
					if { [string match {(%)} $symbol] != 0 } {
						bind $w.c.$temp <Button1-ButtonRelease> "catch {$text insert insert \{(%%)\}; wm state $w withdrawn; wm state .smile_selectorBigCat withdrawn} res"
					} else {
						bind $w.c.$temp <Button1-ButtonRelease> "catch {[list $text insert insert $symbol]\; wm state $w withdrawn; wm state .smile_selectorBigCat withdrawn} res" 
					}
					bind $w.c.$temp <Button3-ButtonRelease> "wm state $w withdrawn; wm state .smile_selectorBigCat withdrawn; ::bigsmileys::ChangeSmileyCategory \"$emotion(name)\" \"$emotion(category)\""
				}
			}
			incr temp
		}
		
		moveinscreen $w 5
		event generate $w <Enter>
	
	}

	proc BigCreateSmileyMenu { categ categnum } {
		global emotions emotions_names 
		global custom_emotions 

		set w .smile_selectorBig_c$categ
		if {[catch {[toplevel $w]} res]} {
			destroy $w
			toplevel $w
		}
		
		#Calculate the total number of smileys (including custom ones)
		set emoticon_number $categnum
		
		#Fixed smiley size
		set smiw 52
		set smih 52
		
		#We want to keep a certain ratio:
		# cols/(rows+1) = 4/3
		# we know cols*rows>=emoticon_number
		#This is the solution of solving that equation system
		set ratio [expr {4.0/3.0}]
		set cols [expr {ceil(($ratio+sqrt(($ratio*$ratio)+4.0*$ratio*$emoticon_number))/2.0)}]
		set rows [expr {ceil(double($emoticon_number) / $cols)}]

		#status_log "Smileys: $emoticon_number. Cols: $cols. Rows: $rows\n" white
		set cols [expr {int($cols)}]
		set rows [expr {int($rows)}]
		
		set x_geo [expr {$smiw*$cols + 2} ]
		set y_geo [expr {$smih*$rows + 2} ]
		
		
		wm state $w withdrawn
		wm geometry $w ${x_geo}x${y_geo}
		wm title $w "[trans msn]"
		wm overrideredirect $w 1
		wm transient $w
		
		
		canvas $w.c -background white -borderwidth 0 -relief flat \
			-selectbackground white -selectborderwidth 0 
		pack $w.c -expand true -fill both
		
		set emot_num 0
		set emot_pos 0
		
		#Now add custom emotions
		foreach name [array names custom_emotions] {
			
			set tmp_do 0
			array set emotion $custom_emotions($name)
			if { $categ == "" } { set tmp_do 1 }
			if { [info exists emotion(category)] && $emotion(category) == $categ } { set tmp_do 1 }
			if { ![info exists emotion(category)] && $categ == [trans others]  } { set tmp_do 1 }
			if { $tmp_do == 1 } {			

				if {![info exists emotion(animated)]} { set emotion(animated) 0 }
				set animated [expr {$emotion(animated)}]
				
				BigCreateSmileyInMenu $w.c $cols $rows $smiw $smih \
					$emot_num $emot_pos $name [lindex $emotion(text) 0] $emotion(image_name) $emotion(file) 1
		
				incr emot_pos
			}
			incr emot_num
		}
		bind $w <Enter> "bind $w <Leave> \"bind $w <Leave> \\\"wm state $w withdrawn\\\"\"; "

	}
	

	proc BigCreateSmileyMenuCat { {text text} } {

		global custom_emotions 
		global custom_emotions_categories
		
		set w .smile_selectorBigCat
		if {[catch {[toplevel $w]} res]} {
			destroy $w
			toplevel $w
		}
		
		#Fixed smiley size
		set smiw 150
		set smih 30
		
		set cols 1
		foreach categ [array names custom_emotions_categories] {
			set custom_emotions_categories($categ) 0
		}
		set tmp_others 0
		foreach name [array names custom_emotions] {
			array set emotion $custom_emotions($name)
			if {[info exists emotion(category)]} {
				if {[info exists custom_emotions_categories($emotion(category))]} {
					incr custom_emotions_categories($emotion(category))
				} else {
					set custom_emotions_categories($emotion(category)) 1
				}
			} else {
				set emotion(category) [trans others]
				set custom_emotions($name) [array get emotion]
				incr tmp_others
			}
		}
		if {![info exists custom_emotions_categories([trans others])]} {
			set custom_emotions_categories([trans others]) $tmp_others
		} else {
			set custom_emotions_categories([trans others]) [expr { $tmp_others + $custom_emotions_categories([trans others]) }]
		}
		set rows [expr [array size custom_emotions_categories]]

		set x_geo [expr {$smiw*$cols + 2} ]
		set y_geo [expr {$smih*$rows + 2} ]
		
		
		wm state $w withdrawn
		wm geometry $w ${x_geo}x${y_geo}
		wm title $w "[trans msn]"
		wm overrideredirect $w 1
		wm transient $w
		
		
		canvas $w.c -background white -borderwidth 0 -relief flat \
			-selectbackground white -selectborderwidth 0 
		pack $w.c -expand true -fill both
		
		# Now create category buttons
		
		set categ_num 0
		
		foreach categ [array names custom_emotions_categories] {
			if { $custom_emotions_categories($categ) > 0 } {
				label $w.c.$categ_num -text "$categ \($custom_emotions_categories($categ)\)"  -background [$w.c cget -background] -font sboldf
				$w.c create window  0 [expr $categ_num*$smih+$smih/2] -window $w.c.$categ_num -width [expr {150}] -height $smih -anchor w
				bind $w.c.$categ_num <Enter> [list $w.c.$categ_num configure -relief raised]
				bind $w.c.$categ_num <Leave> [list $w.c.$categ_num configure -relief flat]
#				bind $w.c.$categ_num <Button1-ButtonRelease> "bind .smile_selectorBigCat <Leave> \"\";::bigsmileys::BigSmileysMenu \[winfo pointerx $w\] \[winfo pointery $w\] $text $categ $custom_emotions_categories($categ)"
				set ypos [expr {(($rows-1)*$smih + ($smih/2))}]
				incr categ_num
			}
		}		
	
		bind $w <Enter> "bind $w <Leave> \"bind $w <Leave> \\\"wm state $w withdrawn\\\"\""
	}

}
